#include <unordered_map>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    std::unordered_map<std::string, uint64_t> answer_set;
    int k = ans.readInt();
    ans.eoln();
    for (int i = 0; i != k; ++i) {
        std::string k = ans.readString();
        int v = ans.readInt();
        ans.eoln();
        answer_set[k] = v;
    }

    std::unordered_map<std::string, uint64_t> participant_set;
    int pk = ouf.readInt();
    ouf.eoln();
    for (size_t i = 0; i != pk; ++i) {
        std::string pk = ouf.readString();
        int pv = ouf.readInt();
        ouf.eoln();
        participant_set[pk] = pv;
    }

    int unexpected_strings = 0;
    int wrong_values = 0;
    int expected_strings_but_not_found = 0;
    for (const auto& ppair : participant_set) {
        if (answer_set.find(ppair.first) == answer_set.end()) {
            ++unexpected_strings;
            continue;
        }
        if (answer_set[ppair.first] != ppair.second)
            ++wrong_values;
    }
    for (const auto& jpair : answer_set) {
        if (participant_set.find(jpair.first) == participant_set.end()) {
            ++expected_strings_but_not_found;
        }
    }

    double points = 70;
    points -= 10 * (unexpected_strings + wrong_values + expected_strings_but_not_found);
    if (points < 0)
        points = 0;
    quitp(points, "%d unexpected strings, %d wrong values, %d expected but not found strings",
            unexpected_strings, wrong_values, expected_strings_but_not_found);
    return 0;
}
