#include <iostream>
#include <unordered_set>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    int k = ouf.readInt();
    ouf.readEoln();
    size_t total_cases = 0;
    std::unordered_set<std::string> set_of_strings;
    while (!ouf.eof()) {
        std::string s = ouf.readString();
        if (set_of_strings.find(s) != set_of_strings.end()) {
            quitf(_pe, "string \"%s\" found twice", s.c_str());
        } else {
            set_of_strings.insert(s);
        }
        int m = ouf.readInt();
        ouf.readEoln();
        ++total_cases;
        if (total_cases == k) {
            if (!ouf.seekEof()) {
                quitf(_pe, "too many answers, expected %d", k);
            }
        }
    }
    if (total_cases != k) {
        quitf(_pe, "expected %d cases, but %d found", int(k), int(total_cases));
    }
    ouf.readEof();
    quitf(_ok, "ok");
    return 0;
}
