#include "testlib.h"
#include <algorithm>
#include <vector>


// Pretest
#define PRETEST

#define MAX_SCORE 70


bool cmp_second(std::pair<int, int> const &lhs, std::pair<int, int> const &rhs) {
    return lhs.second < rhs.second;
}

int read(InStream &in, std::vector<std::pair<int, int> > &students, int k) {
    std::vector<std::pair<int, int> > groups(k);
    std::vector<int> group_sizes(k, 0);
    
    for (int i = 0; i != students.size(); ++i) {
        int group = in.readInt(1, k);
        --group;
        
        groups[group].first += students[i].first;
        groups[group].second += students[i].second;
        ++group_sizes[group];
    }
    
    int grp_size = (int)students.size() / k;
    for (int i = 0; i != k; ++i) {
        if (group_sizes[i] != grp_size) {
            in.quitf(_wa, "Group %d size is %d, expected %d", i + 1, group_sizes[i], grp_size);
        }
    }
    
    int math_min = std::min_element(groups.begin(), groups.end())->first;
    int math_max = std::max_element(groups.begin(), groups.end())->first;
    int prog_min = std::min_element(groups.begin(), groups.end(), cmp_second)->second;
    int prog_max = std::max_element(groups.begin(), groups.end(), cmp_second)->second;
    
    return math_max - math_min + prog_max - prog_min;
}


int main(int argc, char **argv) {
    registerTestlibCmd(argc, argv);
    
    int n = inf.readInt();
    int k = inf.readInt();
    
    std::vector<std::pair<int, int> > students(n);
    for (int i = 0; i != n; ++i) {
        students[i].first = inf.readInt();
        students[i].second = inf.readInt();
    }
    
#ifndef PRETEST
    int ja = read(ans, students, k);
#endif
    int pa = read(ouf, students, k);
    
#ifdef PRETEST
    quitf(_ok, "Q = %d", pa);
#else
    if (pa < ja) {
        quitf(_fail, "Q = %d < Q_min = %d", pa, ja);
    }
    
    if (pa == ja) {
        quitp((double)MAX_SCORE);
    } else {
        quitp((double)std::max(0, MAX_SCORE - (pa - ja)));
    }
#endif
}