#include "testlib.h"

const bool pre_check = false;
const int score_per_test = 6;

const int maxn = 10;

int field[maxn][maxn];
int d[maxn][maxn];

int solve(int n) {
    d[0][0] = field[0][0];
    for (int i = 1; i < n; ++i) {
        d[i][0] = d[i - 1][0] & field[i][0];
        d[0][i] = d[0][i - 1] & field[0][i];
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 1; j < n; ++j) {
            if (field[i][j]) {
                d[i][j] = d[i - 1][j] + d[i][j - 1];
            } else {
                d[i][j] = 0;
            }
        }
    }
    return d[n - 1][n - 1];
}

int main(int argc, char **argv) {
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    int m = inf.readInt();
    double scores = 0;
    for (int test = 0; test < m; ++test) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                field[i][j] = ouf.readInteger(0, 1);
            }
        }
        if (!pre_check && (solve(n) ==  inf.readInt())) {
            scores += score_per_test;
        }
    }
    //ouf.readEof();
    if (!pre_check) {
        quitp(scores);
    } else {
        quitf(_ok, "N * N * M integers in range [0; 1]");
    }
}
